#Controller
function csere1()
pop = opt();
n_pop = size(pop,1);
n_knobs = 3;
count_out = 50;
ber_thres = 0;
bw_thres = 10e6;
pwr_thres = 0;
cur_ber = 99;
cur_bw = 99;
cur_pwr = 99;
good = 0;
counter = 0;
while not(good);
aug_pop = pop;
for p=1:1:n_pop
act = pop(p,:);

a = size(act);
ber = kb(act);
aug_pop(p,n_knobs+1)=ber;
end
[max_score, best]=rank(aug_pop);
[bw, ber] = radio(best);
kb(best,ber);
cur_ber = ber;
cur_pwr = best(n_knobs);
cur_bw = bw;
record = [best bw ber];
save(csere1.dat,record,-ASCII,-append)
counter = counter +1;
if cur_ber <= ber_thres
if cur_pwr <= pwr_thres
if cur_bw <= bw_thres
disp(answer found)
disp(counter)
good = 1;
end
end
end
if counter > count_out
good =1;
disp(count out)
end
if not(good)
pop=opt(best);
end
end

#Optimizer
function pop=opt(seed)
if nargin<1
seed = -1;
end
n_pop = 15;
n_knobs = 3;
knob_lev = [3 3 6];
knobs = [2 4 8 0 0 0;
1 2 3 0 0 0;
-10 -5 0 5 10 15];
pop = zeros(n_pop, n_knobs);
if seed == -1
% Random Pop
for p=1:1:n_pop
for q=1:1:n_knobs
top = knob_lev(q);
idx = randi([1 top],1);
pop(p,q) = knobs(q,idx);
end
end
else
for p=1:1:n_pop
direct = n_knobs-mod(p,n_knobs);
for q=1:1:n_knobs
if q==direct
pop(p,q)=seed(q);
else
top = knob_lev(q);
idx = randi([1 top],1);
pop(p,q) = knobs(q,idx);
end
end
end
end

#Ranker

function [max_score, best]=rank(aug_pop)
max_score = -99;
max_idx = -1;
n_pop = size(aug_pop,1);
for p=1:1:n_pop
mod_sc = aug_pop(p,1);
rate_sc = aug_pop(p,2);
pwr_sc = aug_pop(p,3);
ber_sc = aug_pop(p,4);
mod_sc = log2(mod_sc);
rate_sc = -1*rate_sc+4;
pwr_sc = 4 + pwr_sc/(-5);
ber_sc = round(-11*ber_sc+6);
score = sum([mod_sc rate_sc pwr_sc ber_sc]);
if score > max_score
max_score = score;
max_idx = p;
end
end
best = aug_pop(max_idx,1:3);

#Radio

function [bw, ber] = radio(act)
M = act(1);
rate = act(2);
pwr = act(3);
% Source
x = randi([0,1],1024,1);
% Encoder
switch rate
case 1
n = 15;
k = 11;
case 2
n = 15;
k = 7;
case 3
n = 15;
k = 5;
end
len_x = size(x,1);
num_pad = k-mod(len_x,k);
code = [x;zeros(num_pad,1)];
enc = fec.bchenc(n,k);
code = encode(enc,code);
len_code = size(code,1);
eff = len_x/len_code;
% Modulation
mod_len = log2(M);
mod_pad = mod_len - mod(len_code,mod_len);
code=[code;zeros(mod_pad,1)];
h = modem.dpskmod(M,M, InputType,bit);
y = modulate(h,code);
% Channel
n_pwr = -15+2*randn(1);
snr = pwr - n_pwr;
rx = awgn(y,snr);
% Demodulation
h = modem.dpskdemod(M,M, OutputType,bit);
z = demodulate(h,rx);
z = z(1:len_code);
dec = fec.bchdec(n,k);
uncode = decode(dec,z);
uncode = uncode(1:len_x);
bw = 1/log2(M)*1/eff*6e6*(1.5);
bad_count = nnz(xor(x,uncode));
ber = bad_count/len_x;

#Knowledge Base

function ber=kb(act,adber)
if nargin<2
adber = -1;
end
filename = kb.dat;
act_size = size(act,2);
row = -1;
% Load Database
if exist(filename)
dat_base=load(filename,-ASCII);
act_base = dat_base(:,1:act_size);
base_size = size(act_base,1);
% Find Row
finder = repmat(act, base_size,1);
finder = act_base-finder;
finder = sum(finder,2);
row = find(finder==0);
if size(row,1)==0
row = -1;
end
else
dat_base = -1;
end
if adber~=-1
%In
sav_act = act;
sav_act(act_size+1)=adber;
if dat_base ==-1;
dat_base =[sav_act];
else
if row ==-1
dat_base = [dat_base;sav_act];
else
old_adber = dat_base(row,act_size+1);
new_adber = mean([old_adber,adber]);
dat_base(row,act_size+1)=new_adber;
end
end
save(filename,dat_base, -ASCII);
ber =-1;
else
%out
if dat_base == -1
ber = 0.25;
else
if row == -1
ber = 0.25;
else
ber = dat_base(row,act_size+1);
end
end
end
