#!/usr/bin/env python
#
#
#
#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING. If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#
######################################################################
#usage = "usage: %prog [options] -f cen_freq -m modulation -s packet-size
--tx-amplitude=value"
#Example: python benchmark_coded_ofdm_tx.py -f 2.422G -m qpsk -s 508
--tx-amplitude=8000
#######################################################################
from gnuradio import gr, blks2,ofdm_packet_utils
from gnuradio import usrp
from gnuradio import eng_notation
from gnuradio.eng_option import eng_option
from optparse import OptionParser
import random, time, struct, sys, math, os
import gnuradio.gr.gr_threading as _threading
# from current dir
from coded_transmit_path import coded_transmit_path
from pick_bitrate import pick_tx_bitrate
import fusb_options
class my_top_block(gr.top_block):
def __init__(self, options):
gr.top_block.__init__(self)
self._tx_freq = options.tx_freq # tranmitters center frequency
self._tx_subdev_spec = options.tx_subdev_spec # daughterboard to use
self._interp = options.interp # interpolating rate
self._fusb_block_size = options.fusb_block_size # usb info for USRP
self._fusb_nblocks = options.fusb_nblocks # usb info for USRP
if self._tx_freq is None:
sys.stderr.write("-f FREQ or --freq FREQ must be specified\n")
raise SystemExit
# Set up USRP sink; also adjusts interp, and bitrate
self._setup_usrp_sink()
self.txpath = coded_transmit_path(options)
self.rxpath = coded_receive_path(options)
self.connect(self.txpath, self.u)
# ///////////////////////////////////////////////////////////////////
# The Remaining methods for declaration of USRP and
# other methods for changing parameters of USRP are similiar to
# OFDM (GNU radio examples)
# /////////////////////////////////////////////////////////////////////
# /////////////////////////////////////////////////////////////////////////////
# main ( traffic generation and packet transmission)
# /////////////////////////////////////////////////////////////////////////////
def main():
def send_pkt(payload=, eof=False):
return tb.txpath.send_pkt(payload, eof)
######## Function to generate the random Markov OFF(0)
## and ON(1) states based on Transition Matrix P ############
def gen_markov_states(no_of_sts, trans_matx):
global Mk_states
Mk_states = []
# generates uniform r.v of length equal to markov states
unif_rv=[ random.random() for i in xrange(no_of_sts-1)]
## Generate Initial state based on prior probabilites of ON and OFF
# that are obtained by solving AP = A; where A = [ Pr(S_0 = 0) Pr(S_1 =1]
y=random.random()
if y < 0.464:
MK_states.append(0)
else:
Mk_states.append(1)
## Generate states based on algorithm discussed in Appendix A
for i in range(no_of_sts):
if(Mk_states[i]==1):
if (unif_rv[i]<trans_matx[1][0]):
Mk_states.append(0)
else:
Mk_states.append(1)
if(Mk_states[i]==0):
if (unif_rv[i]<trans_matx[0][1]):
Mk_states.append(1)
else:
Mk_states.append(0)
#### Function to return the packets for
## ON traffic that follow uniform distribution
def gen_ON_pkts(ON_traffic_pkts,ON_traffic_prs):
uni_rv =random.random()
if uni_rv < ON_traffic_prs[0] :
no_of_pkts = ON_traffic_pkts[0]
if uni_rv > ON_traffic_prs[0] and uni_rv < ON_traffic_prs[0] \
+ ON_traffic_prs[1]:
no_of_pkts = ON_traffic_prs[1]
if uni_rv > ON_traffic_prs[0] + ON_traffic_prs[1] and uni_rv < 1 :
no_of_pkts = ON_traffic_prs[2]
## Function for determining the no of packets of former ON
## state to evaluate the OFF time for the current OFF state
def tym_OFF_pkts(no_of_pkts):
arr=[]
arr.append(no_of_pkts)
tym_oFF=arr[len(arr)-1]
return tym_OFF
parser = OptionParser(option_class=eng_option, conflict_handler="resolve")
expert_grp = parser.add_option_group("Expert")
parser.add_option("-s", "--size", type="eng_float", default=508,
help="set packet size [default=\%default]")
parser.add_option("-M", "--megabytes", type="eng_float", default=1.0,
help="set megabytes to transmit [default=\%default]")
parser.add_option("", "--no-of-sts", type="eng_float", default=1000,
help="set no of states of Markov traffic [default=\%default]")
parser.add_option("-P", "--transition-matrix", type="eng_float", \
default = [[0.25, 0.75],[0.35,0.65]],
help="set transition matrix for Markov traffic")
parser.add_option("", "--pkts-ON-traffic", type="eng_float", \
default = [40,60,80],
help = " set the packets for ON traffic (supports three)")
parser.add_option("", "--prs-ON-traffic", type="eng_float", \
default = [0.45,0.3,0.25],
help = "set the probabilities for packets (corresponds to ON traffic)")
parser.add_option("","--from-file", default=None,
help="use file for packet contents")
parser.add_option("", "--fsm-file", default =None,
help= " use for setting the FSM parameters of channel encoder")
my_top_block.add_options(parser, expert_grp)
coded_transmit_path.add_options(parser, expert_grp)
blks2.ofdm_mod.add_options(parser, expert_grp)
blks2.ofdm_demod.add_options(parser, expert_grp)
fusb_options.add_options(expert_grp)
(options, args) = parser.parse_args ()
if options.from_file is not None:
source_file = open(options.from_file, r)
pkt_size = int(options.size)
## set the Markov states, transition matrix and ON traffic parameters
Mk_states = options.no_of_sts
Mk_tran_matx = options.transition_matrix
ON_traffic_pkts = options.pkts_ON_traffic
ON_traffic_prs =options.prs_ON_traffic
# build the graph
tb = my_top_block(options)
r = gr.enable_realtime_scheduling()
if r != gr.RT_OK:
print "Warning: failed to enable realtime scheduling"
tb.start() # start flow graph
# Start the thread to watch the coded payload that are acquired
# from messge queue so as to pass through OFDM modulator blocks.
txr_watcher = _queue_watcher_thread_txr(tb.txpath.coded_pkt_msgq,\
tb.txpath.ofdm_tx._pkt_input)
# Call the Function to generate Markov states
# based on transition matrix and number of states
gen_markov_states(Mk_states, Mk_tran_matx)
# Initialize the parameters for the loop
count_state=0
current_state= 0
no_of_pkts = 0
pktinfo = 1
while (count_state<Mk_states):
if Mk_states[current_state]==1:
print "\n ON state"
pktno= 1
no_of_pkts=gen_ON_pkts(ON_traffic_pkts, ON_traffic_prs)
print " No of packets that are transmitted", no_of_pkts
while pktno<=no_of_pkts:
if options.from_file is None:
data = (pkt_size - 2) * chr(pktno & 0xff)
else:
data = source_file.read(pkt_size - 2)
if data == :
break;
payload = struct.pack(!H, pktinfo & 0xffff) + data
send_pkt(payload)
time.sleep(0.01) # transition time between packets
txr_watcher.pkt_run() # Start the other thread
sys.stderr.write(.)
pktno+=1
pktinfo+=1
else:
print "\n OFF state"
### Determining the OFF period depending on the former ON period.
#The value of OFF cycles are selected based on alogirthm in Appendix A
tymoff=tym_OFF_pkts(no_of_pkts)
if (tymoff==ON_traffic_pkts[0]):
tm=5.0
elif (tymoff==ON_traffic_pkts[1]):
tm=6.0
elif (tymoff==ON_traffic_pkts[2]):
tm=8.0
else:
tm=2.0
print "Time of Sleep for OFF state is \%d secs" \% (tm)
time.sleep(tm) ## OFF period that includes the additional time
count_state+=1 ## for switching ON and OFF or OFF and ON states
current_state+=1
txr_watcher.pkt_run(eof=True) #Indicate the thread for the finish of packets.
send_pkt(eof=True)
tb.wait() # wait for it to finish
## Thread to transmit the coded payload stream to OFDM modulator blocks.
class _queue_watcher_thread_txr(_threading.Thread):
def __init__(self, pkt_msgq,pkt_input):
_threading.Thread.__init__(self)
self.setDaemon(1)
self.pkt_msgq = pkt_msgq
self.pkt_input = pkt_input
self.start()
def pkt_run(self,eof= False):
if eof:
coded_msg=gr.message(1)
else:
msg = self.pkt_msgq.delete_head()
time.sleep(0.01) ### transition time between the threads.
msg_string=msg.to_string()
coded_pkt=ofdm_packet_utils.make_packet(msg_string, 1, \
1, pad_for_usrp=False, whitening=True)
coded_msg = gr.message_from_string(coded_pkt)
self.pkt_input.msgq().insert_tail(coded_msg)

# /////////////////////////////////////////////////////////////////////////////
# Coded OFDM transmit flow-graph
# /////////////////////////////////////////////////////////////////////////////
class coded_transmit_path(gr.hier_block2):
def __init__(self, options):
gr.hier_block2.__init__(self, "coded_transmit_path",
gr.io_signature(0, 0, 0), # Input signature
gr.io_signature(1, 1, gr.sizeof_gr_complex))
self._verbose = options.verbose # turn verbose mode on/off
self._tx_amplitude = options.tx_amplitude # digital amplitude sent to USRP
#####Channel Coding blocks ########
self.uncoded_pkt_input=gr.message_source(gr.sizeof_char,4)
### The FSM file contains the FSM parameters
fsm_st=trellis.fsm(options.fsm_file)
## determine the input and output bits
bitspersymbol = int(round(math.log(fsm_st.I())/math.log(2)))
codedsymbolperbits=int(round(math.log(fsm_st.O())/math.log(2)))
K= ((int(options.size)+4)*8)/bitspersymbol
interleaver=trellis.interleaver(K,666)
## pack and unpack to pass the required bits based on channel encoder
self.pack_unpack=gr.packed_to_unpacked_bb(bitspersymbol,gr.GR_MSB_FIRST)
self.trell_enc= trellis.encoder_bb(f,0)
self.inter = trellis.permutation(interleaver.K(),interleaver.INTER(),\
1,gr.sizeof_char)
self.unpack_pack=gr.unpacked_to_packed_bb(codedsymbolperbits,gr.GR_MSB_FIRST)
self.coded_pkt_msgq=gr.msg_queue()
self.coded_msg_sink=gr.message_sink((gr.sizeof_char),self.coded_pkt_msgq,False)
##############################
self.ofdm_tx = \
blks2.ofdm_mod(options,msgq_limit=4, pad_for_usrp=False)
self.amp = gr.multiply_const_cc(1)
self.set_tx_amplitude(self._tx_amplitude)
# Display some information about the setup
if self._verbose:
self._print_verbage()
# Create and setup transmit path flow graph
self.connect(self.uncoded_pkt_input,self.pack_unpack,self.trell_enc,self.inter)
self.connect(self.inter,self.unpack_pack,self.coded_msg_sink)
self.connect(self.ofdm_tx, self.amp, self)
# ///////////////////////////////////////////////////////////////////
# The Remaining methods for declaration of OFDM parameters and
# other methods for changing them 
# /////////////////////////////////////////////////////////////////////
if __name__ == __main__:
try:
main()
except KeyboardInterrupt:
pass
