#!/usr/bin/env python
#

#
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING. If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
from gnuradio import gr, gru, modulation_utils
from gnuradio import usrp
from gnuradio import eng_notation
from gnuradio.eng_option import eng_option
from optparse import OptionParser
import random,struct,sys,math,time
# Import from current directory
import usrp_dynamic_str_path
#############  ##########################
# Parameters and functional spec
#Two modes : Synchronous and Data traffic ; default = sync_traffic
# sync_traffic : Exhange of BCN, ACK, ACK-ACK signal for mutual handshake
# data_traffic : Actual data traffic b/w SUs
# sync_str provide the representation for BCN(b),ACK(a) and ACK-ACK(o) signal
# node_st provides the SUs node transmitter (t) and receiver (r)
#usage = "usage: \%prog [options] -f cen_freq -m modulation -r data rate"
#Example: python benchmark_coded_ofdm_tx.py -f 2.422G -m gmsk -r 250k
#################################################################################
# ///////////////////////////////////////////////////////////
# Top block
# ///////////////////////////////////////////////////////////
class my_top_block(gr.top_block):
def __init__(self, demodulator, modulator,rx_callback,options):
gr.top_block.__init__(self)
# Set up the dynamic flow graph (receive,transmit or sense path)
self.dynamic_str_path = usrp_dynamic_str_path.usrp_dynamic_str_path(demodulator,\
modulator, rx_callback, options)
self.connect(self.dynamic_str_path)
# Global Variables
global n_rcvd,n_right,mode, data_pktno
mode = "sync_traffic"
# /////////////////////////////////////////////////////////////////////////////
# main
# /////////////////////////////////////////////////////////////////////////////
def main():
global n_rcvd,n_right,frame_power,mode,channel
global traffic_status
n_rcvd = 0
n_right = 0
frame_power=0
###### Receiver Info ##############
def rx_callback(ok, payload): # Callback method for reception of packets ##
global n_rcvd, n_right,mode
global channel,traffic_status
if (mode == "sync_traffic") :
if ok:
(pktno,) = struct.unpack(!H, payload[0:2])
(sync,) = struct.unpack(s, payload[2])
(state,) = struct.unpack (s, payload[3])
(ch_no,) = struct.unpack(!H, payload[4:6])
if (str(sync) == a and str(ch_no) == str(channel)):
if (str(state) == r):
traffic_status = "txr"
mode = "data_traffic"
sync_str = o
node_st = t
ack_ack_payload = struct.pack(!HssH, pktno & 0xffff,\
sync_str,node_st,channel & 0xffff)
send_pkt(ack_ack_payload)
print "Received Ack Signal,Transmit Acknowlegment for Ack Signal"
print " ok = %5s pktno = %4d" %(ok,pktno)
if (str(sync) == b and str(ch_no) == str(channel)):
sync_str = a
node_st = t
ack_payload = struct.pack(!HssH, pktno & 0xffff,\
sync_str,node_st,channel & 0xffff)
send_pkt(ack_payload)
print " Recevied Beacon Signal,Transmit Ack Signal"
print "ok = %5s pktno = %4d" %(ok,pktno)
if (str(sync) == o and str(ch_no) == str(channel)):
mode = "data_traffic"
if (str(state) == r):
traffic_status = "txr"
print "Received Acknowledgment for Ack Signal"
print "ok =%5s pktno =%4d" %(ok,pktno)
if mode == "data_traffic":
if (len(str(payload[0:2])) == 2):
(data_pktno,) = struct.unpack(!H, payload[0:2])
(hdr, ) = struct.unpack(!s , payload[2])
if(str(hdr) == h ) :
n_rcvd += 1
if ok:
n_right += 1
print "ok = %5s data_pktno = %4d n_rcvd = %4d n_right = %4d" \
% (ok, data_pktno,n_rcvd,n_right)
###### Transmitter Info ##############
def send_pkt(payload=, eof=False):
return tb.dynamic_str_path.send_pkt(payload, eof)
def tx_packets():
nbytes = 15
pkt_size = options.size
n = 0
while n < nbytes:
hdr = h
if options.from_file is None:
data=(pkt_size - 3) * chr(data_pktno & 0xff)
else:
data=source_file.read(pkt_size-2)
if data == :
break
payload = struct.pack(!Hs, data_pktno & 0xffff,hdr) + data
send_pkt(payload)
time.sleep(0.02)
n += 1
sys.stderr.write(.)
data_pktno += 1
###### Sensing Info ##############
def set_sensing(freqs):
global frame_power
tb.dynamic_str_path.setup_scan_info(freqs[0],freqs[1])
# no of center frequencies to be scanned
nsteps = tb.dynamic_str_path.str_path.nsteps
## scan_mode is method implemented in gr.bin_statistics.cc to
# start the scanning for primary channel
tb.dynamic_str_path.stats.scan_mode(int(nsteps))
tb.dynamic_str_path.sensing()
frame_power = tb.dynamic_str_path.str_path.avg_frame_power
###### Channel Info ##############
def chan_info(ch_no):
dict_cen={}
dict_minmax={}
cen_freq=["2.422G","2.452G", "2.457G","2.462G"]
channel_no=[3,9,10,11]
min_freq=["2.421G","2.451G","2.456G","2.461G"]
max_freq=["2.423G","2.453G","2.458G","2.463G"]
for i in range(len(channel_no)):
dict_minmax[channel_no[i]]=[min_freq[i],max_freq[i]]
ky=dict_minmax.keys()
val=dict_minmax.values()
for i in range(len(ky)):
if (ky[i]==ch_no):
freqs=val[i]
for i in range(len(channel_no)):
dict_cen[channel_no[i]]=cen_freq[i]
ky1=dict_cen.keys()
val1=dict_cen.values()
for i in range(len(ky1)):
if (ky1[i]==ch_no):
cen_freq=val1[i]
cen_freq=eng_notation.str_to_num(cen_freq)
freqs[0]=eng_notation.str_to_num(freqs[0])
freqs[1]=eng_notation.str_to_num(freqs[1])
return freqs,cen_freq
###########
##### Command Line arguments for transmission
## reception and sensing Flowgraphs ######
demods = modulation_utils.type_1_demods()
mods = modulation_utils.type_1_mods()
# Create Options Parser:
parser = OptionParser (option_class=eng_option, conflict_handler="resolve")
expert_grp = parser.add_option_group("Expert")
parser.add_option("-m", "--modulation", type="choice", choices=mods.keys(),
default=dbpsk,
help="Select modulation from: %s [default=%%default]"
% (, .join(mods.keys()),))
parser.add_option("-s", "--size", type="eng_float", default=1500,
help="set packet size [default=%default]")
parser.add_option("-M", "--megabytes", type="eng_float", default=1.0,
help="set megabytes to transmit [default=%default]")
parser.add_option("","--from-file", default=None,
help="use file for packet contents")
usrp_dynamic_str_path.add_options(parser, expert_grp)
for mod in mods.values():
mod.add_options(expert_grp)
for mod in demods.values():
mod.add_options(expert_grp)
(options, args) = parser.parse_args()
# build the graph
tb = my_top_block(demods[options.modulation],\
mods[options.modulation], rx_callback, options)
if options.from_file is not None:
source_file = open(options.from_file, r)
r = gr.enable_realtime_scheduling()
if r != gr.RT_OK:
print "Warning: Failed to enable realtime scheduling."
tb.start() # start flow graph
running = True
pktno=0
data_pktno = 0
print "Sensing Mode(Sense the primary channel)"
while running:
if (mode == "sync_traffic"):
# random selection of channels
channel=int(random.choice([10,11]))
# Dynamic change of flow-graph to connect only sensing flow-graph
tb.dynamic_str_path.configure_rxr_sense()
scan_freqs,cen_freq=chan_info(channel)
set_sensing(scan_freqs)
#Dynamic change of flow-graph to disconnect sensing flow-graph
# and connect transmission and reception flow-graphs
tb.dynamic_str_path.configure_sense_rxr()
#######Decision Statistics based on MAP testing ########
# stats follow gaussian distribution (each mean and variance are known)
dec_stats_OFF = (1/(math.sqrt(2*math.pi*1.53))) * \
(math.exp(-((frame_power - 27.168)**2)/(2*1.53)))
dec_stats_ON = (1/(math.sqrt(2*math.pi*2.89))) * \
(math.exp(-((frame_power - 44.040)**2)/(2*2.89)))
dec_stats = (dec_stats_OFF/dec_stats_ON)
mk_ON_OFF_ratio=(0.35/0.75)
if ( dec_stats > mk_ON_OFF_ratio):
print "Primary Channel %d is Busy" %(channel)
continue
######
# set the center frequency for txr and rxr
tb.dynamic_str_path.usrp_source.set_center_freq(cen_freq)
tb.dynamic_str_path.usrp_sink.set_center_freq(cen_freq)
nbytes = 6
pkt_size = 6
n = 0
while n < nbytes:
sync_str = b
node_st = t
payload = struct.pack(!HssH, pktno & 0xffff,sync_str,\
node_st, channel & 0xffff)
send_pkt(payload)
n += len(payload)
sys.stderr.write(.)
pktno += 1
time.sleep(0.1)
#####################
if (mode == "data_traffic" ):
if (traffic_status == "txr"):
tx_packet()
time.sleep(0.4) # transition time to switch to sensing cycle
if (traffic_status == "rxr") :
time.sleep(2.0)
mode ="sync_traffic"
time.sleep(0.1) # transition time to switch to sensing cycle
class dynamic_str_path(gr.hier_block2):
def __init__(self, demod_class, mod_class,rx_callback,\
options,usrp_rate,usrp_source,usrp_sink):
gr.hier_block2.__init__(self, "dynamic_str_path",
gr.io_signature(0, 0, 0),
gr.io_signature(0, 0, 0))
####################################################################
# Receiver and Transmitter flow-graphs : Packet modulator blocks
# Sensing Flow-graph : usrp_spectrum_sense.py
# Connect the initial Sensing flowgraph
self.connect(self.packet_transmitter, self.amp, self.usrp_sink)
self.connect(self.usrp_source,self.ampl)
self.connect(self.ampl,self.channel_filter,self.packet_receiver)
self.connect(self.ampl,self.s2v,self.fft,self.c2mag,self.stats)
###############################################
# Sensing for channel in piece-wise average periodogram analysis
def sensing(self):
frame_count=0
self.frame_power=0
mid_stats = zeros(self.nsteps*self.fft_size)
psd_stats = zeros ((self.nsteps * self.fft_size) - ((self.nsteps-1)*64))
count=0
while (frame_count!=1):
m = parse_msg(self.msgq.delete_head())
fshift=array(m.data)
f_shift=fftshift(fshift)
freq_stats=zeros(len(m.data))
for i in xrange(len(m.data)):
freq_stats[i]= 10*math.log10(f_shift[i]/(self.norm_win_pow*len(m.data)))
mid_stats[count+i] = freq_stats[i]
if (m.center_freq == self.max_center_freq):
# Evaluating the periodogram stats for all centre
#frequencies (including averaging the overlapping bins)
for i in range(0,64):
psd_stats[i] = mid_stats[i]
for i in range(0,self.nsteps):
for j in range( (i*self.fft_size+64),((i+1)*self.fft_size - 64)):
psd_stats[j-64*i] = mid_stats[j]
for i in range((self.nsteps*self.fft_size)-64,(self.nsteps*self.fft_size)):
psd_stats [i -(64*(self.nsteps-1))] = mid_stats[i]
for i in range(1,self.nsteps): # Averaging the overlapping bins
for j in range(0,64):
psd_stats[i*self.fft_size-64*i + j] = \
(mid_stats[i*self.fft_size-64+j]+ mid_stats[i*self.fft_size + j])/2
self.avg_frame_power = (psd_stats.sum()/(self.nsteps*self.fft_size))
#print "The average power of frame" ,self.avg_frame_power
frame_count += 1
94else:
count = count + self.fft_size
if __name__ == __main__:
try:
main()
except KeyboardInterrupt:
pass